# -*- coding: utf-8 -*-
## GrufSpaces
## Group environments for elaborating and exchanging information
## Copyright (C)2006 Ingeniweb

## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; see the file COPYING. If not, write to the
## Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
# 
#
# Generated by dumpDCWorkflow.py written by Sebastien Bigaret
# Original workflow id/title: groupspace_published_workflow/GroupSpace Workflow [GRUF]
# Date: 2006/02/16 11:27:17.593 GMT+1
#
# WARNING: this dumps does NOT contain any scripts you might have added to
# the workflow, IT IS YOUR RESPONSABILITY TO MAKE BACKUPS FOR THESE SCRIPTS.
#
# No script detected in this workflow
# 
"""
Programmatically creates a workflow type
"""
__version__ = "$Revision: 32583 $"[11:-2]

from Products.CMFCore.WorkflowTool import addWorkflowFactory

from Products.DCWorkflow.DCWorkflow import DCWorkflowDefinition

def setupGroupspace_published_workflow(wf):
    "..."
    wf.setProperties(title='GroupSpace Workflow [GRUF]')

    for s in ['published']:
        wf.states.addState(s)
    for t in []:
        wf.transitions.addTransition(t)
    for v in ['action', 'time', 'actor', 'comments', 'review_history']:
        wf.variables.addVariable(v)
    for l in ['reviewer_queue']:
        wf.worklists.addWorklist(l)
    for p in ('Access contents information', 'Modify portal content', 'View', 'List folder contents', 'GrufSpaces: Assign GroupSpace Roles', 'GrufSpaces: Edit GroupSpaces', 'GrufSpaces: Send Mail to GroupSpace Members', 'ATContentTypes: Add Document', 'ATContentTypes: Add Event', 'ATContentTypes: Add Favorite', 'ATContentTypes: Add File', 'ATContentTypes: Add Folder', 'ATContentTypes: Add Image', 'ATContentTypes: Add Link', 'ATContentTypes: Add Large Plone Folder', 'ATContentTypes: Add News Item', 'Manage properties'):
        wf.addManagedPermission(p)
        

    ## Initial State
    wf.states.setInitialState('published')

    ## States initialization
    sdef = wf.states['published']
    sdef.setProperties(title="""Published GroupSpace""",
                       transitions=())
    sdef.setPermission('Access contents information', 1, ['GroupAdmin', 'GroupLeader', 'GroupMember', 'GroupVisitor', 'Manager', 'Owner'])
    sdef.setPermission('Modify portal content', 1, ['GroupAdmin', 'GroupLeader', 'Manager', 'Owner'])
    sdef.setPermission('View', 1, ['GroupAdmin', 'GroupLeader', 'GroupMember', 'GroupVisitor', 'Manager', 'Owner'])
    sdef.setPermission('List folder contents', 1, ['GroupAdmin', 'GroupLeader', 'GroupMember', 'GroupVisitor', 'Manager', 'Owner'])
    sdef.setPermission('GrufSpaces: Assign GroupSpace Roles', 1, ['GroupAdmin', 'GroupLeader', 'Manager', 'Owner'])
    sdef.setPermission('GrufSpaces: Edit GroupSpaces', 1, ['GroupAdmin', 'GroupLeader', 'Manager', 'Owner'])
    sdef.setPermission('GrufSpaces: Send Mail to GroupSpace Members', 1, ['GroupAdmin', 'GroupLeader', 'GroupMember', 'Manager', 'Owner'])
    sdef.setPermission('ATContentTypes: Add Document', 0, ['Manager'])
    sdef.setPermission('ATContentTypes: Add Event', 0, ['Manager'])
    sdef.setPermission('ATContentTypes: Add Favorite', 0, ['Manager'])
    sdef.setPermission('ATContentTypes: Add File', 0, ['Manager'])
    sdef.setPermission('ATContentTypes: Add Folder', 0, ['Manager'])
    sdef.setPermission('ATContentTypes: Add Image', 0, ['Manager'])
    sdef.setPermission('ATContentTypes: Add Link', 0, ['Manager'])
    sdef.setPermission('ATContentTypes: Add Large Plone Folder', 0, ['Manager'])
    sdef.setPermission('ATContentTypes: Add News Item', 0, ['Manager'])
    sdef.setPermission('Manage properties', 0, ['GroupAdmin', 'GroupLeader', 'Manager'])


    ## Transitions initialization
    ## State Variable
    wf.variables.setStateVar('review_state')

    ## Variables initialization
    vdef = wf.variables['action']
    vdef.setProperties(description="""The last transition""",
                       default_value="""""",
                       default_expr="""transition/getId|nothing""",
                       for_catalog=0,
                       for_status=1,
                       update_always=1,
                       props=None)

    vdef = wf.variables['time']
    vdef.setProperties(description="""Time of the last transition""",
                       default_value="""""",
                       default_expr="""state_change/getDateTime""",
                       for_catalog=0,
                       for_status=1,
                       update_always=1,
                       props=None)

    vdef = wf.variables['actor']
    vdef.setProperties(description="""The ID of the user who performed the last transition""",
                       default_value="""""",
                       default_expr="""user/getId""",
                       for_catalog=0,
                       for_status=1,
                       update_always=1,
                       props=None)

    vdef = wf.variables['comments']
    vdef.setProperties(description="""Comments about the last transition""",
                       default_value="""""",
                       default_expr="""python:state_change.kwargs.get('comment', '')""",
                       for_catalog=0,
                       for_status=1,
                       update_always=1,
                       props=None)

    vdef = wf.variables['review_history']
    vdef.setProperties(description="""Provides access to workflow history""",
                       default_value="""""",
                       default_expr="""state_change/getHistory""",
                       for_catalog=0,
                       for_status=0,
                       update_always=0,
                       props={'guard_permissions': 'Request review; Review portal content'})

    ## Worklists Initialization
    ldef = wf.worklists['reviewer_queue']
    ldef.setProperties(description="""Reviewer tasks""",
                       actbox_name="""Pending (%(count)d)""",
                       actbox_url="""%(portal_url)s/search?review_state=pending""",
                       actbox_category="""global""",
                       props={'guard_permissions': 'Review portal content', 'var_match_review_state': 'pending'})


def createGroupspace_published_workflow(id):
    "..."
    ob = DCWorkflowDefinition(id)
    setupGroupspace_published_workflow(ob)
    return ob

addWorkflowFactory(createGroupspace_published_workflow,
                   id='groupspace_published_workflow',
                   title='GroupSpace Workflow [GRUF]')

    
