# -*- coding: utf-8 -*-
## GrufSpaces
## Group environments for elaborating and exchanging information
## Copyright (C)2006 Ingeniweb

## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; see the file COPYING. If not, write to the
## Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#
# Runs all tests in the current directory
#
# Execute like:
#   python runalltests.py
#
# Alternatively use the testrunner:
#   python /path/to/Zope/utilities/testrunner.py -qa
#

import os, sys
if __name__ == '__main__':
    execfile(os.path.join(sys.path[0], 'framework.py'))
from unittest import TestSuite
suite = TestSuite()

#######################################
from Products.funittest import set_mode
from Products.funittest import set_projectname
from Products.funittest import get_final_remarks

set_mode("PloneSelenium")
set_projectname("GrufSpaces")

from Products.funittest import set_dependencies
REQUIRED = 1
OPTIONAL = 0
dependencies = [ (REQUIRED, "PloneSelenium"),
                 (OPTIONAL, "CMFPlacefulWorkflow"),
                 (REQUIRED, "GrufSpaces"),
               ]
set_dependencies(dependencies)

# Include Logical Functional Model support
from Products.PloneFunctional.ftests.cmfplone.logicalfunctionalmodel import * 
from Products.PloneFunctional.ftests.cmfplone.dataprovider import * 
from Products.PloneFunctional.ftests.cmfplone.physicalobjectmodel import * 
from Products.PloneFunctional.ftests.cmfplone.expectedstategenerator import * 
from Products.PloneFunctional.ftests.pythonscript import PythonScriptProducer
from grufspaces.dataprovider import *
from grufspaces.logicalfunctionalmodel import *
from grufspaces.physicalobjectmodel import *
from grufspaces.expectedstategenerator import *
from cmfplone.expectationmatrix import * 
#######################################

from Products.funittest import funittestcase

tests = os.listdir(os.curdir)
tests = [n[:-3] for n in tests if n.startswith('test') and n.endswith('.py')]

for test in tests:
    m = __import__(test)
    if hasattr(m, 'test_suite'):
        suite.addTest(m.test_suite())

if __name__ == '__main__':
    ftest_file = open("../skins/grufspaces/get_generated_grufspaces_ftests.py",'w')
    messages=None
    ploneversion="2.1.2"
    base=""
    producer = PythonScriptProducer(messages, ploneversion, base, stream=ftest_file)
    result=producer.run(suite)
    ftest_file.close()
    print "Wrote get_generated_grufspaces_ftests.py file"
    get_final_remarks()
