# -*- coding: utf-8 -*-
## GrufSpaces
## Group environments for elaborating and exchanging information
## Copyright (C)2006 Ingeniweb

## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; see the file COPYING. If not, write to the
## Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
from Products.funittest import DataProvider
from Products.funittest import dataprovider

class GroupSpaceUser(DataProvider):
    def provide(self, **args):
        # groupspace users
        DataProvider.provide(self, **args)
        # Also register as normal plone users so that the users can get created using
        # the standard procedure
        # Omitting the groupspace roles on purpose
        try:
            dataprovider.user.provide(id=args['id'],
                                       fullname=args['fullname'],
                                       roles=args['roles'])        
        except:
            pass
            
    def populate(self):
        context = dataprovider.navigation.current
        if not context.meta_type=="ATGroupSpace":
            raise "Not a GroupSpace" + context.meta_type
        for user in self.all():
            for role in user['groupspace_roles']:
                context.assignCollabRoleToUser(role, user['id'])
                
default = {'fullname':'A GroupSpace Member',
           'roles':['Member',],
           'groupspace_roles':['GroupMember',],
           }    
key="fullname"           
user = GroupSpaceUser("GrufSpaces", default, key)
provide = user.provide

for user in dataprovider.user.all():
    # Also provide the normal users in our users
    provide(id=user['id'],
            fullname=user['fullname'],
            roles=user['roles'],
            groupspace_roles=[])


provide(id='samplegroupmember',
        fullname='Sample Group Member',
        roles=['Member',],
        groupspace_roles=['GroupMember',])
provide(id='samplegroupvisitor',
        fullname='Sample Group Visitor',
        roles=['Member',],
        groupspace_roles=['GroupVisitor'])
provide(id='samplegroupadmin',
        fullname='Sample Group Admin',
        roles=['Member'],
        groupspace_roles=['GroupAdmin',])
provide(id='samplegroupleader',
        fullname='Sample Group Leader',
        roles=['Member',],
        groupspace_roles=['GroupLeader',])
        
        