# -*- coding: utf-8 -*-
## GrufSpaces
## Group environments for elaborating and exchanging information
## Copyright (C)2006 Ingeniweb

## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; see the file COPYING. If not, write to the
## Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
from Products.funittest import interpreter
from Products.funittest import logical
from Products.funittest import physical
from Products.funittest import register_lfm

class Email:
    def send_email_to_all(self, groupspace, email):
        interpreter.annotate("Send email to all in GroupSpace %s" %groupspace['title'])
        physical.email.access_email_to_all(groupspace),
        physical.email.fillEmailForm(email)
        physical.email.send() 
        
    def send_email_to_role(self, groupspace, email, groupspacerole):
        interpreter.annotate("Send email to a role in the GroupSpace %s" %groupspace['title'])
        physical.email.access_email_to_role(groupspace, groupspacerole)
        physical.email.fillEmailForm(email)
        physical.email.send() 
        
    def send_email_to_member(self, groupspace, email, groupspacemember):
        interpreter.annotate("Send email to a member in the GroupSpace %s" %groupspace['title'])
        physical.email.access_email_to_member(groupspace, groupspacemember)
        physical.email.fillEmailForm(email)
        physical.email.send() 

    def send_email_to_selected(self, groupspace, email, groupspaceusers):
        interpreter.annotate("Send email to selected members in the GroupSpace %s" %groupspace['title'])
        physical.email.access_email_to_selected(groupspace, groupspaceusers)
        physical.email.fillEmailForm(email)
        physical.email.send() 

register_lfm("GrufSpaces", Email())
