# -*- coding: utf-8 -*-
## GrufSpaces
## Group environments for elaborating and exchanging information
## Copyright (C)2006 Ingeniweb

## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; see the file COPYING. If not, write to the
## Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
__author__  = 'Maik Roeder <maik.roeder@ingeniweb.com>'
__docformat__ = 'restructuredtext'


import os, sys
if __name__ == '__main__':
    execfile(os.path.join(sys.path[0], 'framework.py'))

from Testing import ZopeTestCase # side effect import. leave it here.

from Products.funittest import interpreter
from Products.funittest import logical
from Products.funittest import dataprovider
from Products.funittest import physical

tests = []

from Products.funittest import funittestcase
funittestcase.setupPloneSite()
class TestAreasFunctional(funittestcase.FUnitTestCase):
    "GroupSpace content type tests"
    def setUp(self):
        funittestcase.FUnitTestCase.setUp(self)
        self.setRoles(['Manager'])
        dataprovider.user.populate()
        
        # Always logout before logging in
        logical.application.logout()
        user1 = dataprovider.user.take("Sample Manager")
        logical.application.login(user1)
       
        # We want GroupSpaces with areas
        config = dataprovider.configuration.filtered_choice(areas=1)
        logical.configlet.configure(config)
        
        # Take any GroupSpace with areas and add it to the site
        groupspace=dataprovider.areagroupspaces.choice()
        logical.navigation.top()
        logical.folder.delete_using_url(groupspace)
        logical.navigation.top()
        logical.folder.add(groupspace)
        logical.content.edit(groupspace)
        logical.content.save(groupspace)
        
    def test_access_groupspace_areas(self):
        "Access areas of a GroupSpace"
        for area in dataprovider.areas.all():
            logical.navigation.down(area)
            logical.navigation.up()
            
tests.append(TestAreasFunctional)

if __name__ == '__main__':
    framework()
else:
    # While framework.py provides its own test_suite()
    # method the testrunner utility does not.
    import unittest
    def test_suite():
        suite = unittest.TestSuite()
        for test in tests:
            suite.addTest(unittest.makeSuite(test))
        return suite
