# -*- coding: utf-8 -*-
## GrufSpaces
## Group environments for elaborating and exchanging information
## Copyright (C)2006 Ingeniweb

## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; see the file COPYING. If not, write to the
## Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
__author__  = 'Maik Roeder <maik.roeder@ingeniweb.com>'
__docformat__ = 'restructuredtext'


import os, sys
if __name__ == '__main__':
    execfile(os.path.join(sys.path[0], 'framework.py'))

from Testing import ZopeTestCase # side effect import. leave it here.

from Products.funittest import interpreter
from Products.funittest import logical
from Products.funittest import dataprovider
from Products.funittest import physical

tests = []

from Products.funittest import funittestcase
funittestcase.setupPloneSite()
class TestEmailFunctional(funittestcase.FUnitTestCase):
    "Email"

    def setUp(self):
        funittestcase.FUnitTestCase.setUp(self)
        self.setRoles(['Manager'])
        logical.navigation.top()
        dataprovider.groupspaces.populate()
        for groupspace in dataprovider.groupspaces.all():
            logical.navigation.top()
            logical.navigation.down(groupspace)
            dataprovider.groupspaceuser.populate()
    
    def test_send_mail_to_selected_members(self):
        "send a mail to the group"
        groupspace = dataprovider.groupspaces.choice()
        users = dataprovider.groupspaceuser.sample()
        email = dataprovider.groupspaceemails.choice()
        logical.email.send_email_to_selected(groupspace, email, users)
        
    def test_send_mail_to_all_members(self):
        "send a mail to the group"
        groupspace = dataprovider.groupspaces.choice()
        email = dataprovider.groupspaceemails.choice()
        logical.email.send_email_to_all(groupspace, email)
        users=dataprovider.groupspaceuser.all()
     
    def test_send_mail_to_role(self):
        "send a mail to the group"
        groupspace = dataprovider.groupspaces.choice()
        role=dataprovider.groupspaceroles.choice()
        email = dataprovider.groupspaceemails.choice()
        logical.email.send_email_to_role(groupspace, email, role)

    def test_send_mail_to_member(self):
        "send a mail to the group"
        groupspace = dataprovider.groupspaces.choice()
        user = dataprovider.groupspaceuser.choice()
        email = dataprovider.groupspaceemails.choice()
        logical.email.send_email_to_member(groupspace, email, user)

tests.append(TestEmailFunctional)

if __name__ == '__main__':
    framework()
else:
    # While framework.py provides its own test_suite()
    # method the testrunner utility does not.
    import unittest
    def test_suite():
        suite = unittest.TestSuite()
        for test in tests:
            suite.addTest(unittest.makeSuite(test))
        return suite
