# -*- coding: utf-8 -*-
## GrufSpaces
## Group environments for elaborating and exchanging information
## Copyright (C)2006 Ingeniweb

## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; see the file COPYING. If not, write to the
## Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
__author__  = 'Maik Roeder <maik.roeder@ingeniweb.com>'
__docformat__ = 'restructuredtext'

import os, sys
if __name__ == '__main__':
    execfile(os.path.join(sys.path[0], 'framework.py'))

from Testing import ZopeTestCase # side effect import. leave it here.

from Products.funittest import interpreter
from Products.funittest import logical
from Products.funittest import dataprovider
from Products.funittest import physical

tests = []

from Products.funittest import funitelaboratedtestcase
funitelaboratedtestcase.setupPloneSite()

class TestGroupSpaceFunctional(funitelaboratedtestcase.FUnitTestCase):
    "GroupSpace content type tests"

    preconditions = ['user', 'context', 'configuration']
    populations = []
    
    def predict_open_groupspace(conf):

        configuration = conf['configuration']
        success = 0
        if configuration['areas']==0:
           success = 1
        if not success:
            return success           
    
        user = conf['user']
        if not user.has_key('groupspace_roles'):
            return # Needs to be a GroupSpace member
        success = 0            
        if 'GroupAdmin' in user['groupspace_roles']:
            success = 1
        if 'GroupLeader' in user['groupspace_roles']:
            success = 1
        if 'Manager' in user['roles']:
            success = 1
        if not success:
            return # user is not allowed
 
        context = conf['context']            
        success = 1        
        if not context['type_name'] == 'GroupSpace':
            success = 0
        if not context['transitions' == ['open']:
            success = 0
        if not success:
            return success

        
    def setUp(self):
        funittestcase.FUnitTestCase.setUp(self)
        self.setRoles(['Manager'])
        config = dataprovider.configuration.filtered_choice(areas=0)
        logical.configlet.configure(config)
        logical.navigation.top()
        dataprovider.groupspaces.populate()
        dataprovider.user.populate()
                
    def test_open_groupspace(self):
        "Open a GroupSpace"
        groupspace = dataprovider.groupspaces.take("Closed GroupSpace")
        logical.groupspaces.close_groupspace(groupspace)

    def test_close_groupspace(self):
        "Close a GroupSpace"
        groupspace = dataprovider.groupspaces.take("Open GroupSpace")
        logical.groupspaces.close_groupspace(groupspace)

tests.append(TestGroupSpaceFunctional)

if __name__ == '__main__':
    framework()
else:
    # While framework.py provides its own test_suite()
    # method the testrunner utility does not.
    import unittest
    def test_suite():
        suite = unittest.TestSuite()
        for test in tests:
            suite.addTest(unittest.makeSuite(test))
        return suite
