## Script (Python) "getGroupSpaceEmailsBccList"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=obj=None, role=None, user=None, group=None
##title=get groupspace emails
##

# Returns unique emails of specific group members or groups

from Products.CMFCore.utils import getToolByName
pg = getToolByName(context, 'portal_groups')
pm = getToolByName(context, 'portal_membership')
reg_tool = getToolByName(context, 'portal_registration')

if not obj:
    obj = context
    
## Get the local roles set on the parent and above
lroles = container.plone_utils.getInheritedLocalRoles(obj)
lroles += container.acl_users.getLocalRolesForDisplay(obj)

groupspace_emails={}

if user:
    user_mail = obj.getMail(user)
    if user_mail:
        groupspace_emails={user:user_mail}
elif group:
     group = pg.getGroupById(group)
     if group:
         for member in group.getGroupMembers():
            user_name=member.getId()
            groupspace_emails[user_name]=obj.getMail(user_name)
else:
    if not role:
        groupspace_roles = ['GroupMember','GroupVisitor','GroupLeader','GroupAdmin']
    elif role:
        groupspace_roles = [role]

    # Get member ids and their emails of all members with the given roles in the groupspace 
    recipients_emails={}
    for role in groupspace_roles:
        for user_name, user_roles, user_type, ignore in lroles:
            if role in user_roles:
                if user_type.strip()=='group':
                    group = pg.getGroupById(user_name)
                    if group:
                        groupmembers = group.getGroupMembers()
                        for member in groupmembers:
                            recipients_emails[member.getId()]=obj.getMail(member.getId())
                elif user_type=='user':
                    recipients_emails[user_name]=obj.getMail(user_name)

    # Verify all emails of the members                         
    if recipients_emails:
        for memberid,  memberemail in recipients_emails.items():
            # We need emails for all member ids in the interface
            if memberemail and reg_tool.isValidEmail(memberemail):
                groupspace_emails[memberid]=memberemail

return groupspace_emails.items()
