## Script (Python) "get_grufspaces_ftests"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=
##title=
##
try:
    return context.get_generated_grufspaces_ftests()
except:
    pass
from Products.CMFCore.utils import getToolByName
selenium = getToolByName(context, 'portal_selenium')
suite = selenium.getSuite()

logical=context.get_grufspaces_lfm(suite)

target_language='en'
suite.setTargetLanguage(target_language)
plone21 = selenium.getPloneVersion() > "2.0.5"
plone212 = selenium.getPloneVersion() >= "2.1.2"
plone25 = selenium.getPloneVersion() >= "2.5"

# Any GroupMember can delete the content of other GroupMembers
groupmembers_can_delete_other_groupmember_documents=1

# Any GroupMember can edit the content of other GroupMembers
groupmembers_can_edit_other_groupmember_documents=1

# Documents inside a closed GroupSpace are not visible to the outside
documents_not_visible_in_closed_groupspace=1

# Normal Members can not access a GroupSpace
groupspace_not_accessible_to_members=1

selenium.addUser(id = 'sampleadmin',fullname='Sample Admin',roles=['Member', 'Manager',])
selenium.addUser(id = 'samplemember',fullname='Sample Group Member',roles=['Member',])
selenium.addUser(id = 'samplegroupmember',fullname='Sample Group Member',roles=['Member',])
selenium.addUser(id = 'othergroupmember',fullname='Other Group Member',roles=['Member',])
selenium.addUser(id = 'samplegroupvisitor',fullname='Sample Group Visitor',roles=['Member',])
selenium.addUser(id = 'samplegroupadmin',fullname='Sample Group Admin',roles=['Member',])
selenium.addUser(id = 'samplegroupleader',fullname='Sample Group Leader',roles=['Member',])
selenium.addGroup(id = 'samplegroup',roles=[])
selenium.addGroup(id = 'samplegroup_1',roles=[])
selenium.addGroup(id = 'samplegroup_2',roles=[])

# 1
test_logout = suite.TestLogout()
test_sampleadmin_login  = suite.TestLoginPortlet('sampleadmin')
test_samplemember_login  = suite.TestLoginPortlet('samplemember')
test_samplegroupmember_login  = suite.TestLoginPortlet('samplegroupmember')
test_othergroupmember_login  = suite.TestLoginPortlet('othergroupmember')
test_samplegroupvisitor_login  = suite.TestLoginPortlet('samplegroupvisitor')
test_samplegroupadmin_login  = suite.TestLoginPortlet('samplegroupadmin')
test_samplegroupleader_login  = suite.TestLoginPortlet('samplegroupleader')
test_switch_language = suite.TestSwitchToLanguage()

group_folder = 'groups'
group_id = 'samplegroup'
groupspace_path = '/' + group_folder + '/' + group_id


document_fields=[]
document_fields.append({'id':'title',
                        'value':'Test Document'})
document_fields.append({'id':'description',
                        'value' : 'This is the test document'})
document_fields.append({'id':'text',
                        'value' : 'QWERTY'})
document = {'type':'Document',
            'fields':document_fields}
if plone212 or plone25:
    document['id']='test-document'
else:
    document['id']='testdocument'

other_document_fields=[]
other_document_fields.append({'id':'title',
                        'value':'Other Test Document'})
other_document_fields.append({'id':'description',
                        'value' : 'This is another test document'})
other_document_fields.append({'id':'text',
                        'value' : 'This is the body text of another test document'})
other_document = {'type':'Document',
            'fields':other_document_fields}
if plone212 or plone25:
    other_document['id']='other-test-document'
else:
    other_document['id']='othertestdocument'

group_fields=[]
group_fields.append({'id':'title',
                        'value':'Groups'})
group_fields.append({'id':'description',
                        'value' : 'Groups'})
group = {'id':'groups',
         'type':'Folder',
         'fields':group_fields,}

groupspace_fields=[]
groupspace_fields.append({'id':'title',
                          'value':'Test GroupSpace'})
groupspace_fields.append({'id':'description',
                          'value' : 'This is a Test Groupspace'})
groupspace = {'id':group_id,
              'type':'GroupSpace',
             'fields':groupspace_fields,}

test_delete_groupvisitor = t = suite.getTest()
t.open("%s/GroupSpace_rolesForm" % groupspace_path)
t.click("user/samplegroupvisitor/GroupVisitor")
t.clickAndWait("form.button.Delete")
t.verifyTextPresent("Role assignment changed.")
          
test_add_groupvisitor = t = suite.getTest()
t.open("%s/GroupSpace_rolesForm" % groupspace_path)
t.type('user_search_term','samplegroupvisitor')
t.clickAndWait("perform_user_search")
t.select("user_collab_role", "GroupVisitor")
t.clickAndWait("form.button.Save")
t.verifyTextPresent("Role assignment changed.")


def test_add_groupspace_to_group_folder():
    t = suite.getTest()
    # Add GroupSpace
    # Delete existing GroupSpace for a fresh start
    if plone21:
        t.open("/%s/folder_delete?paths:list=%s" % (group_folder, t.base + groupspace_path))
    else:
        t.open("/%s/folder_delete?ids:list=%s" % (group_folder, group_id))
    t.open("/" + group_folder)
    
    # Let's add the GroupSpace
    t.clickAndWait( "link=GroupSpace")
    # Fill in the form
    t.type("id", group_id)
    t.type("title", "Test GroupSpace")
    t.type("description", "This is a Test Groupspace")
    # Save
    t.clickAndWait( "form_submit")
    t.verifyTextPresent("Changes saved.")
    return t

def test_delete_document_in_groupspace(document):
    if groupmembers_can_delete_other_groupmember_documents:
        return suite.test_delete_content(groupspace_path, document)
    else:
        return suite.test_can_not_delete_content(groupspace_path, document)

def setup_groupspace(areas=0, user_search=1, group_selection=1):
    t = suite.getTest()
    t += test_sampleadmin_login
    t += test_switch_language
    if areas:
        t += logical.config.test_areas_on()
    else:
        t += logical.config.test_areas_off()
    if user_search:
        t += logical.config.test_user_search_on()
    else:
        t += logical.config.test_user_selection_on()
    
    if group_selection:
        t += logical.config.test_group_selection_on()
    else:
        t += logical.config.test_group_search_on()
     
    t += logical.groupspace.test_add_group_folder_for_groupspaces(group)
    t += test_add_groupspace_to_group_folder()
    return t

suite.addTests("Standard new groupspace should be empty",
          'Setup standard GroupSpace',
          setup_groupspace(),
          'GroupSpace should be empty',
          suite.open(groupspace_path),
          suite.verifyTextPresent("There are currently no items in this folder."),
          )

suite.addTests("Standard GroupSpace should use open close workflow",
          'Setup standard GroupSpace',
          setup_groupspace(),
          'GroupSpace should use open close workflow',
          suite.open(groupspace_path + '/manage_workflowsTab'),
          suite.verifyTextPresent("groupspace_open_close_workflow"),
          )

suite.addTests("New GroupSpace with areas should contain areas",
          'Setup GroupSpace with areas',
          setup_groupspace(areas=1),
          'GroupSpace should contain areas',
          suite.open(groupspace_path + '/public'),
          suite.verifyTextPresent("You are here"),
          suite.verifyTextPresent("There are currently no items in this folder."),
          suite.open(groupspace_path + '/shared'),
          suite.verifyTextPresent("You are here"),
          suite.verifyTextPresent("There are currently no items in this folder."),
          suite.open(groupspace_path + '/resources'),
          suite.verifyTextPresent("You are here"),
          suite.verifyTextPresent("There are currently no items in this folder."),
          suite.open(groupspace_path + '/test'),
          suite.verifyTextPresent("You are here"),
          suite.verifyTextPresent("There are currently no items in this folder."),
          suite.open(groupspace_path + '/box'),
          suite.verifyTextPresent("You are here"),
          suite.verifyTextPresent("There are currently no items in this folder."),
          )

suite.addTests("GroupSpace with areas should use published workflow",
          'Setup GroupSpace with areas',
          setup_groupspace(areas=1),
          'GroupSpace should use published workflow',
          suite.open(groupspace_path + '/manage_workflowsTab'),
          suite.verifyTextPresent("groupspace_published_workflow"),
          )

suite.addTests("GroupMembers can add and delete each others content in GroupSpace",
          'Setup standard GroupSpace',
          setup_groupspace(),
          'Share GroupSpace',
          logical.groupspace.test_share_groupspace(groupspace_path),
          'Login as Sample Group Member',
          test_samplegroupmember_login,
          test_switch_language,
          'Add content',
          logical.groupspace.test_add_document_to_groupspace(groupspace_path, document),
          'Login as Other Group Member',
          test_othergroupmember_login,
          test_switch_language,
          'Add content',
          logical.groupspace.test_add_document_to_groupspace(groupspace_path, other_document),
          'Delete content',
          test_delete_document_in_groupspace(document),
          test_delete_document_in_groupspace(other_document),
         )

suite.addTests("GroupAdmin can open a GroupSpace",
          'Setup standard GroupSpace',
          setup_groupspace(),
          'Share GroupSpace',
          logical.groupspace.test_share_groupspace(groupspace_path),
          'Login as Group Admin',
          test_samplegroupadmin_login,
          test_switch_language,
          'Open GroupSpace',
          suite.open("%s/content_status_modify?workflow_action=open" % groupspace_path),

# XXX

         )

suite.addTests("GroupLeader can open a GroupSpace",
          'Setup standard GroupSpace',
          setup_groupspace(),
          'Share GroupSpace',
          logical.groupspace.test_share_groupspace(groupspace_path),
          'Login as Group Leader',
          test_samplegroupleader_login,
          test_switch_language,
          'Open GroupSpace',
          suite.open("%s/content_status_modify?workflow_action=open" % groupspace_path),

# XXX

         )

suite.addTests("GroupAdmin can add and remove GroupVisitors",
          'Setup standard GroupSpace',
          setup_groupspace(),
          'Share GroupSpace',
          logical.groupspace.test_share_groupspace(groupspace_path),
          'Login as Group Admin',
          test_samplegroupadmin_login,
          test_switch_language,
          'Delete GroupVisitor role of samplegroupvisitor',
          test_delete_groupvisitor,
          'Add GroupVisitor role to samplegroupvisitor',
          test_add_groupvisitor,
          )

suite.addTests("GroupLeader can add and remove GroupVisitors",
          'Setup standard GroupSpace',
          setup_groupspace(),
          'Share GroupSpace',
          logical.groupspace.test_share_groupspace(groupspace_path),
          'Login as Group Leader',
          test_samplegroupleader_login,
          test_switch_language,
          'Delete GroupVisitor role of samplegroupvisitor',
          test_delete_groupvisitor,
          'Add GroupVisitor role to samplegroupvisitor',
          test_add_groupvisitor,      
         )

# The content of closed GroupSpaces should not be visible to the outside
# When switching between open and closed GroupSpaces, the documents inside
# should automatically become visible and invisible to the outside.

suite.addTests("Member can access an open GroupSpace and its content until it is closed.",
          'Setup standard GroupSpace',
          setup_groupspace(),
          'Share GroupSpace',
          logical.groupspace.test_share_groupspace(groupspace_path),
          'Open GroupSpace',
          suite.open("%s/content_status_modify?workflow_action=open" % groupspace_path),
          'Login as Sample Group Member',
          test_samplegroupmember_login,
          test_switch_language,
          'Add content',
          logical.groupspace.test_add_document_to_groupspace(groupspace_path, document),
          'Search content inside GroupSpace',
          suite.open("/search?SearchableText=QWERTY"),
          suite.verifyTextPresent("1 items matching your criteria"),

          'Login as Sample Member',
          test_samplemember_login,
          'Try accessing the GroupSpace',
          suite.open("%s/" % groupspace_path),
          suite.verifyTextNotPresent("Insufficient Privileges"),
          'Search content inside GroupSpace',
          suite.open("/search?SearchableText=QWERTY"),
          suite.verifyTextPresent("1 items matching your criteria"),

          'Login as Sample Admin',
          test_sampleadmin_login,
          'Close GroupSpace',
          suite.open("%s/content_status_modify?workflow_action=close" % groupspace_path),

          'Login as Sample Member',
          test_samplemember_login,
          'Try accessing the GroupSpace',
          suite.open("%s/" % groupspace_path),
          suite.verifyTextPresent("Insufficient Privileges"),
          'Search content inside GroupSpace',
          suite.open("/search?SearchableText=QWERTY"),
          suite.verifyTextNotPresent("1 items matching your criteria"),
         )

suite.addTests("User Search in Roles Form",
          'Setup standard GroupSpace',
          setup_groupspace(),
          'Search without search term',
          suite.open('/groups/samplegroup/GroupSpace_rolesForm'),
          suite.verifyElementNotPresent('assign_users_to_role'),          
          suite.verifyElementPresent('perform_user_search'),
          suite.clickAndWait('perform_user_search'),
          suite.verifyElementPresent('assign_users_to_role'),          
          suite.verifyElementNotPresent('perform_user_search'),
          'Search without search term and assign without selecting',
          suite.open('/groups/samplegroup/GroupSpace_rolesForm'),
          suite.clickAndWait('perform_user_search'),
          suite.clickAndWait('assign_users_to_role'),
          suite.verifyTextPresent('Please make a selection.'),
          'Search for existing',
          suite.open('/groups/samplegroup/GroupSpace_rolesForm'),
          suite.verifyElementNotPresent('assign_users_to_role'),          
          suite.verifyElementPresent('perform_user_search'),
          suite.type('user_search_term', 'samplemember'),
          suite.clickAndWait('perform_user_search'),
          suite.verifyElementPresent('assign_users_to_role'),          
          suite.verifyElementNotPresent('perform_user_search'),          
          suite.verifyElementPresent("//input[@value='samplemember']"),
          'Search for non-existing',
          suite.open('/groups/samplegroup/GroupSpace_rolesForm'),
          suite.verifyElementNotPresent('assign_users_to_role'),          
          suite.verifyElementPresent('perform_user_search'),
          suite.type('user_search_term', 'nonexistinguser'),
          suite.clickAndWait('perform_user_search'),
          suite.verifyElementNotPresent('assign_users_to_role'),          
          suite.verifyElementPresent('perform_user_search'),          
          suite.verifyTextPresent("No members were found"),
         )

suite.addTests("User Selection in Roles Form",
          'Setup standard GroupSpace',
          setup_groupspace(user_search=0),
          'Assign role to no user should fail',
          suite.open('/groups/samplegroup/GroupSpace_rolesForm'),
          suite.verifyElementPresent('assign_users_to_role'),          
          suite.verifyElementNotPresent('perform_user_search'),
          suite.clickAndWait('assign_users_to_role'),
          suite.verifyTextPresent('Please make a selection.'),
          suite.verifyElementNotPresent('perform_user_search'),
          'Assign role to user should work',
          suite.open('/groups/samplegroup/GroupSpace_rolesForm'),
          suite.verifyElementPresent('assign_users_to_role'),          
          suite.verifyElementNotPresent('perform_user_search'),
          suite.click("//input[@value='samplemember']"),         
          suite.clickAndWait('assign_users_to_role'),
          suite.verifyTextPresent('Role assignment changed.'),
          suite.verifyElementNotPresent('perform_user_search'),
          )

suite.addTests("Group Search in Roles Form",
          'Setup standard GroupSpace',
          setup_groupspace(group_selection=0),
          'Search without search term',
          suite.open('/groups/samplegroup/GroupSpace_rolesForm'),
          suite.verifyElementNotPresent('assign_groups_to_role'),          
          suite.verifyElementPresent('perform_group_search'),
          suite.clickAndWait('perform_group_search'),
          suite.verifyElementPresent('assign_groups_to_role'),          
          suite.verifyElementNotPresent('perform_group_search'),          
          'Search without search term and assign without selecting',
          suite.open('/groups/samplegroup/GroupSpace_rolesForm'),
          suite.clickAndWait('perform_group_search'),
          suite.clickAndWait('assign_groups_to_role'),
          suite.verifyTextPresent('Please make a selection.'),
          'Search for non-existing group',
          suite.open('/groups/samplegroup/GroupSpace_rolesForm'),
          suite.verifyElementNotPresent('assign_groups_to_role'),          
          suite.verifyElementPresent('perform_group_search'),
          suite.type('group_search_term', 'nonexistinggroup'),
          suite.clickAndWait('perform_group_search'),
          suite.verifyElementNotPresent('assign_groups_to_role'),          
          suite.verifyElementPresent('perform_group_search'),          
          suite.verifyTextPresent("No groups were found"),
          'Search for existing group',
          suite.open('/groups/samplegroup/GroupSpace_rolesForm'),
          suite.verifyElementNotPresent('assign_groups_to_role'),          
          suite.verifyElementPresent('perform_group_search'),
          suite.type('group_search_term', 'samplegroup_1'),
          suite.clickAndWait('perform_group_search'),
          suite.verifyElementPresent('assign_groups_to_role'),          
          suite.verifyElementNotPresent('perform_group_search'),          
          suite.verifyElementPresent("//input[@value='samplegroup_1']"),
          'Assign GroupVisitor role to group',
          suite.open('/groups/samplegroup/GroupSpace_rolesForm'),
          suite.type('group_search_term', 'samplegroup'),
          suite.clickAndWait('perform_group_search'),
          suite.click("//input[@value='samplegroup_1']"),
          suite.clickAndWait('assign_groups_to_role'),
          suite.verifyTextPresent("Role assignment changed."),
          suite.verifyElementPresent("id=group/samplegroup_1/GroupVisitor")
          )

          
suite.addTests("Group Selection in Roles Form",
          'Setup standard GroupSpace',
          setup_groupspace(user_search=0),
          'Assign role no group should fail',
          suite.open('/groups/samplegroup/GroupSpace_rolesForm'),
          suite.verifyElementPresent('assign_groups_to_role'),          
          suite.verifyElementNotPresent('perform_group_search'),
          suite.clickAndWait('assign_groups_to_role'),
          suite.verifyTextPresent('Please make a selection.'),
          suite.verifyElementNotPresent('perform_group_search'),
          'Assign role to group should work',
          suite.open('/groups/samplegroup/GroupSpace_rolesForm'),
          suite.verifyElementPresent('assign_groups_to_role'),          
          suite.verifyElementNotPresent('perform_group_search'),
          suite.click("//input[@value='samplegroup']"),
          suite.clickAndWait('assign_groups_to_role'),
          suite.verifyTextPresent('Role assignment changed.'),
          suite.verifyElementNotPresent('perform_group_search'),
         )

suite.addTests("Remove all roles in Roles Form",
          'Setup standard GroupSpace',
          setup_groupspace(user_search=0),
          'Make sure there is at least one user with a role',
          suite.open('/groups/samplegroup/GroupSpace_rolesForm'),
          suite.click("//input[@value='samplemember']"),         
          suite.clickAndWait('assign_users_to_role'),
          'Make sure there is at least one group with a role',
          suite.open('/groups/samplegroup/GroupSpace_rolesForm'),
          suite.click("//input[@value='samplegroup']"),         
          suite.clickAndWait('assign_groups_to_role'),          
          'Remove roles',
          suite.open('/groups/samplegroup/GroupSpace_rolesForm'),
          suite.click('alr_toggle'),
          suite.clickAndWait('form.button.Delete'),
          suite.verifyTextPresent('Role assignment changed.'),
          )

suite.addTests("Shared Area",
          'Setup standard GroupSpace',
          setup_groupspace(areas=1),
          'Share GroupSpace',
          logical.groupspace.test_share_groupspace(groupspace_path),

          'GroupVisitor can not add content in Shared area',
          test_samplegroupvisitor_login,
          suite.open(groupspace_path + "/shared/createObject?type_name=Document"),
          suite.verifyTextPresent("Insufficient Privileges"),
          'Anonymous can not add content in Shared area',
          test_logout,
          suite.open(groupspace_path + "/shared/createObject?type_name=Document"),
          suite.verifyTextPresent("Please log in"),
          'Member can not add content in Shared area',
          test_samplemember_login,
          suite.open(groupspace_path + "/shared/createObject?type_name=Document"),
          suite.verifyTextPresent("Insufficient Privileges"),
          'GroupMember can add content in Shared area',
          test_samplegroupmember_login,
          suite.open(groupspace_path + "/shared/createObject?type_name=Document"),
          suite.verifyElementPresent('title'),
          'GroupAdmin can add content in Shared area',
          test_samplegroupadmin_login,
          suite.open(groupspace_path + "/shared/createObject?type_name=Document"),
          suite.verifyElementPresent('title'),
          'GroupLeader can add content in Shared area',
          test_samplegroupleader_login,
          suite.open(groupspace_path + "/shared/createObject?type_name=Document"),
          suite.verifyElementPresent('title'),

          'GroupMember creates a document in the shared area',
          test_samplegroupmember_login,
          logical.groupspace.test_add_document_to_groupspace_area(groupspace_path + '/shared', document),
          'GroupAdmin edits the document',
          test_samplegroupadmin_login,
          suite.open("/search?SearchableText=QWERTY"),
          suite.verifyTextPresent("1 items matching your criteria"),
          suite.clickAndWait("link=Test Document"),
          suite.clickAndWait("link=Edit"),
          suite.type("text", "Changed by GroupAdmin"),
          suite.clickAndWait(suite.messages['CONTENT_SAVE_BUTTON']['Document']),
          suite.verifyTextPresent(suite.messages['CONTENT_SAVE_MSG']['Document']),
          suite.verifyTextPresent("Changed by GroupAdmin"),
          'GroupMember edits the document',
          test_samplegroupmember_login,
          suite.open("/search?SearchableText=Changed by GroupAdmin"),
          suite.verifyTextPresent("1 items matching your criteria"),
          suite.clickAndWait("link=Test Document"),
          suite.clickAndWait("link=Edit"),
          suite.type("text", "QWERTY"),
          suite.clickAndWait(suite.messages['CONTENT_SAVE_BUTTON']['Document']),
          suite.verifyTextPresent(suite.messages['CONTENT_SAVE_MSG']['Document']),
          suite.verifyTextPresent("QWERTY"),
          suite.open("/search?SearchableText=QWERTY"),
          suite.verifyTextPresent("1 items matching your criteria"),
          'Members of the site can not find the document',
          test_samplemember_login,
          suite.open("/search?SearchableText=QWERTY"),
          suite.verifyTextPresent("No results were found."),
          'Anonymous can not find the document',
          test_logout,
          suite.open("/search?SearchableText=QWERTY"),
          suite.verifyTextPresent("No results were found."),
         )

suite.addTests("Public Area",
          'Setup standard GroupSpace',
          setup_groupspace(areas=1),
          'Share GroupSpace',
          logical.groupspace.test_share_groupspace(groupspace_path),

          'GroupVisitor can not add content in Public area',
          test_samplegroupvisitor_login,
          suite.open(groupspace_path + "/public/createObject?type_name=Document"),
          test_samplegroupadmin_login,
          suite.open(groupspace_path + "/public"),
          suite.verifyTextPresent("There are currently no items in this folder."),
          'Anonymous can not add content in Public area',
          test_logout,
          suite.open(groupspace_path + "/public/createObject?type_name=Document"),
          suite.verifyTextPresent("Please log in"),
          test_samplegroupadmin_login,
          suite.open(groupspace_path + "/public"),
          suite.verifyTextPresent("There are currently no items in this folder."),
          'Member can not add content in Public area',
          test_samplemember_login,
          suite.open(groupspace_path + "/public/createObject?type_name=Document"),
          suite.verifyTextPresent("Insufficient Privileges"),
          test_samplegroupadmin_login,
          suite.open(groupspace_path + "/public"),
          suite.verifyTextPresent("There are currently no items in this folder."),
          'GroupMember can not add content in Public area',
          test_samplegroupmember_login,
          suite.open(groupspace_path + "/public/createObject?type_name=Document"),
          suite.verifyTextPresent("Insufficient Privileges"),
          test_samplegroupadmin_login,
          suite.open(groupspace_path + "/public"),
          suite.verifyTextPresent("There are currently no items in this folder."),
          'GroupAdmin can add content in Public area',
          test_samplegroupadmin_login,
          suite.open(groupspace_path + "/public/createObject?type_name=Document"),
          suite.verifyElementPresent('title'),
          'GroupLeader can add content in Public area',
          test_samplegroupleader_login,
          suite.open(groupspace_path + "/public/createObject?type_name=Document"),
          suite.verifyElementPresent('title'),

          'GroupMember creates a document in the shared area',
          test_samplegroupmember_login,
          logical.groupspace.test_add_document_to_groupspace_area(groupspace_path + '/' + "shared", document),
          'GroupAdmin copies document to the public area',
          test_samplegroupadmin_login,
          suite.open(groupspace_path + "/shared"),
          suite.clickAndWait("link=Contents"),
          suite.click("selectButton"),
          suite.clickAndWait("folder_copy:method"),
          suite.open(groupspace_path + "/public"),
          suite.clickAndWait("link=Contents"),
          suite.clickAndWait("folder_paste:method"),
          "GroupAdmin can find the documents",
          test_samplegroupadmin_login,
          suite.open("/search?SearchableText=QWERTY"),
          suite.verifyTextPresent("2 items matching your criteria"),
          'GroupMember can not copy the document to the public area',
          test_samplegroupmember_login,
          suite.open(groupspace_path + "/shared"),
          suite.clickAndWait("link=Contents"),
          suite.click("selectButton"),
          suite.clickAndWait("folder_copy:method"),
          suite.open(groupspace_path + "/public/folder_contents"),
          suite.verifyElementNotPresent("folder_paste:method"), # Paste button should not be visible
          "GroupMember can find the shared and published document",
          test_samplegroupmember_login,
          suite.open("/search?SearchableText=QWERTY"),
          suite.verifyTextPresent("2 items matching your criteria"),
          'Anonymous can find the document',
          test_logout,
          suite.open("/search?SearchableText=QWERTY"),
          suite.verifyTextPresent("1 items matching your criteria"), # Obviously, the workflow security is not updated when copying!

          'Anonymous can not delete the document in the public area',
          test_logout,
          logical.areas.test_delete_document_in_groupspace_area(groupspace_path + '/' + "public", document),
          suite.verifyElementNotPresent("folder_copy:method"),
          suite.verifyTextPresent("Test Document"),
          'GroupVisitor can not delete the document in the public area',
          test_samplegroupvisitor_login,
          logical.areas.test_delete_document_in_groupspace_area(groupspace_path + '/' + "public", document),
          suite.verifyElementNotPresent("folder_copy:method"),
          suite.verifyTextPresent("Test Document"),
          'GroupMember can not delete the document in the public area',
          test_samplegroupmember_login,
          logical.areas.test_delete_document_in_groupspace_area(groupspace_path + '/' + "public", document),
          suite.verifyElementNotPresent("folder_copy:method"),
          suite.verifyTextPresent("Test Document"),
         )

suite.addTests("Test Area",
          'Setup standard GroupSpace',
          setup_groupspace(areas=1),
          'Share GroupSpace',
          logical.groupspace.test_share_groupspace(groupspace_path),

          'GroupVisitor can not add content in Test area',
          test_samplegroupvisitor_login,
          suite.open(groupspace_path + "/test/createObject?type_name=Document"),
          suite.verifyTextPresent("Insufficient Privileges"),
          'Anonymous can not add content in Test area',
          test_logout,
          suite.open(groupspace_path + "/test/createObject?type_name=Document"),
          suite.verifyTextPresent("Please log in"),
          'Member can not add content in Test area',
          test_samplemember_login,
          suite.open(groupspace_path + "/test/createObject?type_name=Document"),
          suite.verifyTextPresent("Insufficient Privileges"),
          'GroupMember can add content in Test area',
          test_samplegroupmember_login,
          suite.open(groupspace_path + "/test/createObject?type_name=Document"),
          suite.verifyElementPresent('title'),
          'GroupAdmin can add content in Test area',
          test_samplegroupadmin_login,
          suite.open(groupspace_path + "/test/createObject?type_name=Document"),
          suite.verifyElementPresent('title'),
          'GroupLeader can add content in Test area',
          test_samplegroupleader_login,
          suite.open(groupspace_path + "/test/createObject?type_name=Document"),
          suite.verifyElementPresent('title'),

          'GroupMember creates a document in the test area',
          test_samplegroupmember_login,
          logical.groupspace.test_add_document_to_groupspace_area(groupspace_path + '/' + "test", document),
          'GroupAdmin can not find the irrelevant document',
          test_samplegroupadmin_login,
          suite.open("/search?SearchableText=QWERTY"),
          suite.verifyTextPresent("No results were found."),
          'Another GroupMember can not find the irrelevant document',
          test_othergroupmember_login,
          suite.open("/search?SearchableText=QWERTY"),
          suite.verifyTextPresent("No results were found."),
          'Member can not find the irrelevant document',
          test_samplemember_login,
          suite.open("/search?SearchableText=QWERTY"),
          suite.verifyTextPresent("No results were found."),
          'Anonymous can not find the irrelevant document',
          test_logout,
          suite.open("/search?SearchableText=QWERTY"),
          suite.verifyTextPresent("No results were found."),
          'Another GroupMember can destroy the document',
          test_samplemember_login,
          logical.areas.test_delete_document_in_groupspace_area(groupspace_path + '/' + "test", document),
          suite.verifyTextPresent("Insufficient Privileges"),
         )

suite.addTests("Box Area",
          'Setup standard GroupSpace',
          setup_groupspace(areas=1),
          'Share GroupSpace',
          logical.groupspace.test_share_groupspace(groupspace_path),

          'GroupVisitor can not add content in Box area',
          test_samplegroupvisitor_login,
          suite.open(groupspace_path + "/box/createObject?type_name=Document"),
          suite.verifyTextPresent("Insufficient Privileges"),
          'Anonymous can not add content in Box area',
          test_logout,
          suite.open(groupspace_path + "/box/createObject?type_name=Document"),
          suite.verifyTextPresent("Please log in"),
          'Member can not add content in Box area',
          test_samplemember_login,
          suite.open(groupspace_path + "/box/createObject?type_name=Document"),
          suite.verifyTextPresent("Insufficient Privileges"),
          'GroupMember can not add content in Box area',
          test_samplegroupmember_login,
          suite.open(groupspace_path + "/box/createObject?type_name=Document"),
          suite.verifyTextPresent("Insufficient Privileges"),
          'GroupAdmin can add content in Box area',
          test_samplegroupadmin_login,
          suite.open(groupspace_path + "/box/createObject?type_name=Document"),
          suite.verifyElementPresent('title'),
          'GroupLeader can add content in Box area',
          test_samplegroupleader_login,
          suite.open(groupspace_path + "/box/createObject?type_name=Document"),
          suite.verifyElementPresent('title'),

          'GroupMember creates a document in the shared area',
          test_samplegroupmember_login,
          logical.groupspace.test_add_document_to_groupspace_area(groupspace_path + '/' + "shared", document),
          'GroupMember copies the document to the box area',
          suite.open(groupspace_path + "/shared"),
          suite.clickAndWait("link=Contents"),
          suite.click("selectButton"),
          suite.clickAndWait("folder_copy:method"),
          suite.open(groupspace_path + "/box"),
          suite.clickAndWait("link=Contents"),
          suite.clickAndWait("folder_paste:method"),
          suite.verifyTextNotPresent("Unauthorized to paste item(s)."),
          'GroupMember can find the document in the box area',
          suite.open("/search?SearchableText=QWERTY"),
          suite.verifyTextPresent("2 items matching your criteria"),
          'Another GroupMember can not find the document in the box area',
          test_othergroupmember_login,
          suite.open("/search?SearchableText=QWERTY"),
          suite.verifyTextPresent("1 items matching your criteria"),
          'Anonymous can not find the document in the box area',
          test_logout,
          suite.open("/search?SearchableText=QWERTY"),
          suite.verifyTextPresent("No results were found."),
          'GroupAdmin can find the document in the box area',
          test_samplegroupadmin_login,
          suite.open("/search?SearchableText=QWERTY"),
          suite.verifyTextPresent("2 items matching your criteria"),
          'GroupAdmin can edit the document in the box area',
          test_samplegroupadmin_login,
          suite.open("/groups/samplegroup/box/" + document['id']),
          suite.clickAndWait("link=Edit"),
          suite.type("text", "Changed by GroupAdmin"),
          suite.clickAndWait(suite.messages['CONTENT_SAVE_BUTTON']['Document']),
          suite.verifyTextPresent(suite.messages['CONTENT_SAVE_MSG']['Document']),
          suite.verifyTextPresent("Changed by GroupAdmin"),
          'GroupMember can access his own document in the box area',
          test_samplegroupmember_login,
          suite.open("/groups/samplegroup/box/"),
          suite.verifyTextPresent("This is a test document"),
          suite.open("/groups/samplegroup/box/" + document['id']),
          suite.verifyTextPresent("Changed by GroupAdmin"),
          'GroupVisitor can not access the document in the box area',
          test_samplegroupvisitor_login,
          suite.open("/groups/samplegroup/box/"),
          suite.verifyTextPresent("Insufficient Privileges"),
          suite.open("/groups/samplegroup/box/" + document['id']),
          suite.verifyTextPresent("Insufficient Privileges"),
          'OtherGroupMember can not see his the document in the box area',
          test_othergroupmember_login,
          suite.open("/groups/samplegroup/box/"),
          suite.verifyTextPresent("There are currently no items in this folder."),
          suite.open(groupspace_path + "/box/"+ document['id']),
          suite.verifyTextPresent("Insufficient Privileges"),
          'GroupAdmin can see the document in the box area',
          test_samplegroupadmin_login,
          suite.open("/groups/samplegroup/box/"),
          suite.verifyTextPresent("This is a test document"),
          suite.open(groupspace_path + "/box/"+ document['id']),
          suite.verifyTextPresent("Changed by GroupAdmin"),
          'GroupLeader can see the document in the box area',
          test_samplegroupleader_login,
          suite.open("/groups/samplegroup/box/"),
          suite.verifyTextPresent("This is a test document"),
          suite.open(groupspace_path + "/box/"+ document['id']),
          suite.verifyTextPresent("Changed by GroupAdmin"),
         )

suite.addTests("Resources Area",
          'Setup standard GroupSpace',
          setup_groupspace(areas=1),
          'Share GroupSpace',
          logical.groupspace.test_share_groupspace(groupspace_path),

          'GroupVisitor can not add content in Resources area',
          test_samplegroupvisitor_login,
          suite.open(groupspace_path + "/resources/createObject?type_name=Document"),
          suite.verifyTextPresent("Insufficient Privileges"),
          'Anonymous can not add content in Resources area',
          test_logout,
          suite.open(groupspace_path + "/resources/createObject?type_name=Document"),
          suite.verifyTextPresent("Please log in"),
          'Member can not add content in Resources area',
          test_samplemember_login,
          suite.open(groupspace_path + "/resources/createObject?type_name=Document"),
          suite.verifyTextPresent("Insufficient Privileges"),
          'GroupMember can not add content in Resources area',
          test_samplegroupmember_login,
          suite.open(groupspace_path + "/resources/createObject?type_name=Document"),
          suite.verifyTextPresent("Insufficient Privileges"),
          'GroupAdmin can add content in Resources area',
          test_samplegroupadmin_login,
          suite.open(groupspace_path + "/resources/createObject?type_name=Document"),
          suite.verifyElementPresent('title'),
          'GroupLeader can add content in Resources area',
          test_samplegroupleader_login,
          suite.open(groupspace_path + "/resources/createObject?type_name=Document"),
          suite.verifyElementPresent('title'),

          'GroupAdmin creates a document in the shared area',
          test_samplegroupadmin_login,
          logical.groupspace.test_add_document_to_groupspace_area(groupspace_path + '/' + "shared", document),
          'GroupAdmin copies the document to the resources area',
          suite.open(groupspace_path + "/shared"),
          suite.clickAndWait("link=Contents"),
          suite.click("selectButton"),
          suite.clickAndWait("folder_copy:method"),
          suite.open(groupspace_path + "/resources"),
          suite.clickAndWait("link=Contents"),
          suite.clickAndWait("folder_paste:method"),
          suite.verifyTextPresent("Item(s) pasted."),
          'GroupMember can find the document in the resources area',
          test_samplegroupmember_login,
          suite.open("/search?SearchableText=QWERTY"),
          suite.verifyTextPresent("2 items matching your criteria"),
          suite.open(groupspace_path + "/shared/"+ document['id']),
          suite.verifyTextPresent("QWERTY"),
          suite.open(groupspace_path + "/resources/"+ document['id']),
          suite.verifyTextPresent("QWERTY"),
          'GroupVisitor can find the document in the resources area',
          test_samplegroupvisitor_login,
          suite.open("/search?SearchableText=QWERTY"),
          suite.verifyTextPresent("2 items matching your criteria"),
          suite.open(groupspace_path + "/shared/"+ document['id']),
          suite.verifyTextPresent("QWERTY"),
          suite.open(groupspace_path + "/resources/"+ document['id']),
          suite.verifyTextPresent("QWERTY"),
          'Members can not find the document in the resources area',
          test_samplemember_login,
          suite.open("/search?SearchableText=QWERTY"),
          suite.verifyTextPresent("No results were found."),
          suite.open(groupspace_path + "/shared/"+ document['id']),
          suite.verifyTextNotPresent("QWERTY"),
          suite.open(groupspace_path + "/resources/"+ document['id']),
          suite.verifyTextNotPresent("QWERTY"),
          'Anonymous can not find the document in the resources area',
          test_logout,
          suite.open("/search?SearchableText=QWERTY"),
          suite.verifyTextPresent("No results were found."),
          suite.open(groupspace_path + "/shared/"+ document['id']),
          suite.verifyTextNotPresent("QWERTY"),
          suite.open(groupspace_path + "/resources/"+ document['id']),
          suite.verifyTextNotPresent("QWERTY"),
          'GroupAdmin can find the document in the resources area',
          test_samplegroupadmin_login,
          suite.open("/search?SearchableText=QWERTY"),
          suite.verifyTextPresent("2 items matching your criteria"),
          suite.open(groupspace_path + "/shared/"+ document['id']),
          suite.verifyTextPresent("QWERTY"),
          suite.open(groupspace_path + "/resources/"+ document['id']),
          suite.verifyTextPresent("QWERTY"),
          'GroupLeader can find the document in the resources area',
          test_samplegroupleader_login,
          suite.open("/search?SearchableText=QWERTY"),
          suite.verifyTextPresent("2 items matching your criteria"),
          suite.open(groupspace_path + "/shared/"+ document['id']),
          suite.verifyTextPresent("QWERTY"),
          suite.open(groupspace_path + "/resources/"+ document['id']),
          suite.verifyTextPresent("QWERTY"),
         )

suite.addTests("Moving documents around",
          'Setup standard GroupSpace',
          setup_groupspace(areas=1),
          'Share GroupSpace',
          logical.groupspace.test_share_groupspace(groupspace_path),

          'Login as sample member',
          test_samplegroupmember_login,
          'Member Folder cleanup',
          logical.groupspace.test_add_document_to_member_folder("samplegroupmember", document),
          suite.open('/Members/samplegroupmember/folder_contents'),
          suite.click("selectButton"),
          suite.clickAndWait("folder_delete:method"),

          'GroupMember adds a document',
          test_samplegroupmember_login,
          suite.open("/Members/samplegroupmember/createObject?type_name=Document"),
          suite.type("id", 'testdoc174'),
          suite.type("title", 'testdoc174'),
          suite.type("description", 'testdoc174'),
          suite.type("text", 'testdoc174'),
          suite.clickAndWait("form_submit"),
          
          'GroupMember copies document from Member to Shared folder',
          test_samplegroupmember_login,
          suite.open('/Members/samplegroupmember/'),
          suite.clickAndWait("link=Contents"),
          suite.click("selectButton"),
          suite.clickAndWait("folder_copy:method"),
          suite.open(groupspace_path + "/shared"),
          suite.clickAndWait("link=Contents"),
          suite.clickAndWait("folder_paste:method"),
          
          'GroupLeader copies document from Shared folder to Public folder',
          test_samplegroupleader_login,
          suite.open(groupspace_path + "/shared"),
          suite.clickAndWait("link=Contents"),
          suite.click("selectButton"),
          suite.clickAndWait("folder_copy:method"),
          suite.open(groupspace_path + "/public"),
          suite.clickAndWait("link=Contents"),
          suite.clickAndWait("folder_paste:method"),

          'GroupMember should not be able to modify document in public folder',
          test_samplegroupmember_login,
          suite.open(groupspace_path + "/public/testdoc174"),
          suite.verifyElementNotPresent("link=Edit"),

          'Other GroupMember should not be able to modify document in public folder',
          test_othergroupmember_login,
          suite.open(groupspace_path + "/public/testdoc174"),
          suite.verifyElementNotPresent("link=Edit"),
          
          'GroupAdmin should be able to modify document in public folder',
          test_samplegroupadmin_login,
          suite.open(groupspace_path + "/public/testdoc174"),
          suite.verifyElementPresent("link=Edit"),
          )

suite.addTests("Notification in Role Assignment",
          'Setup standard GroupSpace',
          setup_groupspace(),
          'Configure user search',
          logical.config.test_user_search_on(),
          'Admin assigns GroupAdmin with notification',
          logical.groupspace.test_add_role_to_groupspace(groupspace_path, 'samplegroupadmin','GroupAdmin',notify=1),
          'Admin assigns GroupLeader with notification',
          logical.groupspace.test_add_role_to_groupspace(groupspace_path, 'samplegroupleader','GroupLeader',notify=1),
          'GroupAdmin assigns GroupMember with notification',
          test_samplegroupadmin_login,
          logical.groupspace.test_add_role_to_groupspace(groupspace_path, 'samplegroupmember','GroupMember',notify=1),
          'GroupAdmin assigns GroupVisitor with notification',
          test_samplegroupadmin_login,
          logical.groupspace.test_add_role_to_groupspace(groupspace_path, 'samplegroupvisitor','GroupVisitor',notify=1),
          )

return suite
