# -*- coding: utf-8 -*-
## GrufSpaces
## Group environments for elaborating and exchanging information
## Copyright (C)2006 Ingeniweb

## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; see the file COPYING. If not, write to the
## Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

# $Id: $
"""
"""

__author__ = 'Maik Rder <maik.roeder@ingeniweb.com>'
__docformat__ = 'restructuredtext'

from Products.CMFQuickInstallerTool.QuickInstallerTool import AlreadyInstalled
from Products.Archetypes.tests.atsitetestcase import ATSiteTestCase
from Products.PloneTestCase.setup import portal_name
from Testing import ZopeTestCase
import time
from AccessControl.SecurityManagement import newSecurityManager
from Products.PloneTestCase.setup import portal_owner
from Products.CMFCore.utils import getToolByName
from AccessControl.SecurityManagement import noSecurityManager

from Products.Archetypes import transaction

try:
    ZopeTestCase.installProduct('CMFPlacefulWorkflow')
except:
    pass
ZopeTestCase.installProduct('GrufSpaces')

class GrufSpacesTestCase(ATSiteTestCase):
    pass

def setupGS(app, id=portal_name, quiet=False):
    transaction.begin()
    _start = time.time()
    portal = app[id]
    if not quiet: ZopeTestCase._print('Adding GrufSpaces ... ')

    # login as manager
    user = app.acl_users.getUserById(portal_owner).__of__(app.acl_users)
    newSecurityManager(None, user)
    # add ATCT
    qi = getToolByName(portal, 'portal_quickinstaller')
    try:
        qi.installProduct('CMFPlacefulWorkflow')
    except AttributeError:
        # EAFP = easier ask for forgiveness than permission
        if not quiet: ZopeTestCase._print('CMFPlacefulWorkflow is not available ...\n')    
    except AlreadyInstalled:
        # EAFP = easier ask for forgiveness than permission
        if not quiet: ZopeTestCase._print('CMFPlacefulWorkflow already installed ...\n')
    try:
        qi.installProduct('GrufSpaces')
    except AlreadyInstalled:
        # EAFP = easier ask for forgiveness than permission
        if not quiet: ZopeTestCase._print('GrufSpaces already installed ...\n')
    # Log out
    noSecurityManager()
    transaction.commit()
    if not quiet: ZopeTestCase._print('done (%.3fs)\n' % (time.time()-_start,))

app = ZopeTestCase.app()
setupGS(app)
ZopeTestCase.close(app)
